"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withNesting;

var _react = _interopRequireDefault(require("react"));

var _hooks = require("./../hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function withNesting(Component) {
  var Wrapper = /*#__PURE__*/_react.default.forwardRef(function Wrapper(props, ref) {
    var nesting = (0, _hooks.useNesting)();
    return /*#__PURE__*/_react.default.createElement(Component, _extends({}, props, {
      nesting: nesting
    }));
  });

  Wrapper.displayName = Component.displayName;
  return Wrapper;
}