"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = void 0;

var _styles = require("@material-ui/core/styles");

var _colors = require("@material-ui/core/colors");

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
var styles = function styles(theme) {
  return (0, _styles.createStyles)({
    root: {
      padding: theme.spacing(0.4),
      borderRadius: theme.spacing(0.4)
    },
    colorDefault: {
      backgroundColor: theme.palette.type === "light" ? theme.palette.codeSpanBg.main : theme.palette.codeSpanBg.dark
    },
    colorPrimary: {
      backgroundColor: theme.palette.primary.light
    },
    colorSecondary: {
      backgroundColor: theme.palette.secondary.light
    },
    colorGrey: {
      backgroundColor: _colors.grey[200]
    },
    font: {
      fontFamily: "monospace",
      fontWeight: 500,
      fontSize: "inherit"
    },
    textInherit: {
      color: "inherit"
    },
    textWhite: {
      color: theme.palette.common.white
    },
    textBlack: {
      color: theme.palette.common.black
    }
  });
};

exports.styles = styles;