"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = withLangSetup;

var _react = _interopRequireDefault(require("react"));

var _useLang = require("../../hooks/useLang");

var _routingManager = require("routing-manager");

var _CircularProgress = _interopRequireDefault(require("@material-ui/core/CircularProgress"));

var _Box = _interopRequireDefault(require("@material-ui/core/Box"));

var _Typography = _interopRequireDefault(require("@material-ui/core/Typography"));

var _mergeLangs = _interopRequireDefault(require("../../utils/mergeLangs"));

var _ = _interopRequireWildcard(require("lodash"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(n); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function withLangSetup(Component) {
  var Wrapper = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
    var langs = props.langs,
        defaultLang = props.defaultLang,
        onHelpToTranslate = props.onHelpToTranslate,
        other = _objectWithoutProperties(props, ["langs", "defaultLang", "onHelpToTranslate"]);

    var _useChangeRoute = (0, _routingManager.useChangeRoute)(),
        getQueryParams = _useChangeRoute.getQueryParams,
        getRouteParams = _useChangeRoute.getRouteParams,
        changeRoute = _useChangeRoute.changeRoute;

    var _React$useState = _react.default.useState(null),
        _React$useState2 = _slicedToArray(_React$useState, 2),
        lang = _React$useState2[0],
        setLang = _React$useState2[1];

    var _React$useState3 = _react.default.useState(true),
        _React$useState4 = _slicedToArray(_React$useState3, 2),
        loading = _React$useState4[0],
        setLoading = _React$useState4[1];

    var _getQueryParams = getQueryParams(),
        langName = _getQueryParams.l; // Effect for language setup on startup and changing lang on url hash changing.


    _react.default.useEffect(function () {
      if (defaultLang) {
        if (!langName) {
          changeRoute(null, {
            l: defaultLang.name
          });
        }

        if (Array.isArray(langs)) {
          var newLang = langs.find(function (candidate) {
            return candidate.name === langName;
          }) || defaultLang;
          switchLang(newLang).then();
        } else {
          switchLang(defaultLang).then();
        }
      } else {
        setLoading(false);
      }
    }, [langName]); // Effect for setting up loading screen state when locale not loaded.


    _react.default.useEffect(function () {
      if (defaultLang) lang ? setLoading(false) : setLoading(true);
    }, [lang]);

    function switchLangRoute(_x) {
      return _switchLangRoute.apply(this, arguments);
    }

    function _switchLangRoute() {
      _switchLangRoute = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(inputLang) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(_typeof(inputLang) !== "object")) {
                  _context.next = 2;
                  break;
                }

                throw new TypeError("MaterialDocs: incorrect type of lang, expected Lang, got ".concat(_typeof(inputLang)));

              case 2:
                if (!(typeof inputLang.name !== "string")) {
                  _context.next = 4;
                  break;
                }

                throw new TypeError("MaterialDocs: incorrect type of lang.name, expected string, got ".concat(_typeof(inputLang.name)));

              case 4:
                changeRoute(null, {
                  l: inputLang.name
                });

              case 5:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));
      return _switchLangRoute.apply(this, arguments);
    }

    function switchLang(_x2) {
      return _switchLang.apply(this, arguments);
    }

    function _switchLang() {
      _switchLang = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(inputLang) {
        var newLang;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!(_typeof(inputLang) !== "object")) {
                  _context2.next = 2;
                  break;
                }

                throw new TypeError("MaterialDocs: incorrect type of lang, expected Lang, got ".concat(_typeof(inputLang)));

              case 2:
                newLang = _.cloneDeep(inputLang);

                if (!(!inputLang.locale && typeof inputLang.loadLang !== "function")) {
                  _context2.next = 7;
                  break;
                }

                throw new TypeError("MaterialDocs: you must specify in \"inputLang\" one of fields: \"locale: object\" or \"loadLang: function(): object\"");

              case 7:
                if (!inputLang.locale && inputLang.loadLang) {
                  newLang.locale = newLang.loadLang();
                }

              case 8:
                newLang = (0, _mergeLangs.default)(newLang, defaultLang);
                setLang(newLang);

              case 10:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));
      return _switchLang.apply(this, arguments);
    }

    if (loading) return /*#__PURE__*/_react.default.createElement(_Box.default, {
      style: {
        display: "flex",
        position: "absolute",
        top: 0,
        bottom: 0,
        left: 0,
        right: 0,
        justifyContent: "center",
        alignItems: "center"
      }
    }, /*#__PURE__*/_react.default.createElement(_CircularProgress.default, {
      size: 100
    }), /*#__PURE__*/_react.default.createElement(_Box.default, {
      p: 1
    }, /*#__PURE__*/_react.default.createElement(_Typography.default, {
      variant: "h3",
      color: "primary"
    }, "Material Docs is loading..."), /*#__PURE__*/_react.default.createElement(_Typography.default, {
      variant: "h6",
      color: "textSecondary"
    }, "Please wait a couple of time.")));
    return /*#__PURE__*/_react.default.createElement(_useLang.LangContext.Provider, {
      value: {
        lang: lang,
        switchLang: switchLangRoute,
        langs: langs,
        onHelpToTranslate: onHelpToTranslate,
        defaultLang: defaultLang
      }
    }, /*#__PURE__*/_react.default.createElement(Component, _extends({}, other, {
      ref: ref,
      noLanguageSelector: defaultLang ? other.noLanguageSelector : true
    })));
  });

  return Wrapper;
}