"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.styles = void 0;

var _styles = require("@material-ui/core/styles");

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
var styles = function styles(theme) {
  return (0, _styles.createStyles)({
    root: {
      position: "relative",
      display: "flex"
    },
    fullWidth: {
      width: "100%",
      flexGrow: 1
    },
    alignLeft: {},
    alignCenter: {
      justifyContent: "center"
    },
    alignRight: {
      justifyContent: "flex-end"
    },
    frame: {
      border: "3px solid ".concat(theme.palette.type === "light" ? theme.palette.lightgrey.main : theme.palette.lightgrey.dark)
    },
    placeholder: {
      position: "absolute",
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      padding: theme.spacing(3),
      backgroundColor: theme.palette.type === "light" ? theme.palette.whitesmoke.main : theme.palette.whitesmoke.dark,
      display: "flex",
      alignItems: "center",
      justifyContent: "center",
      overflow: "hidden"
    },
    progress: {},
    errorText: {
      width: "100%",
      display: "block",
      textAlign: "center",
      textOverflow: "ellipsis"
    }
  });
};

exports.styles = styles;