"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.displayName = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("../../utils");

var _hooks = require("../../hooks");

var _styles = require("@material-ui/styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
// PropTypes validators
// Utils
var displayName = "MaterialDocs-Locale";
exports.displayName = displayName;

var Locale = /*#__PURE__*/_react.default.forwardRef(function Locale(props, ref) {
  var path = props.path,
      children = props.children;

  var _useLang = (0, _hooks.useLang)(),
      lang = _useLang.lang;

  var text = "";
  if (!lang) console.error("MaterialDocs: you must pass defaultLang to DocsLayout component to use Locale!");
  if (lang && typeof path === "string") text = (0, _utils.getFieldFromLang)(lang, path);
  if (!text) text = children;
  return text;
});

Locale.displayName = displayName;
Locale.propTypes = {
  path: _propTypes.default.string,
  children: _propTypes.default.node
};

var _default = (0, _styles.withStyles)({}, {
  name: displayName
})(Locale);

exports.default = _default;