"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.MaterialDocsSystemContext = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
var MaterialDocsSystemContext = /*#__PURE__*/_react.default.createContext({
  autoMenuData: null,
  author: undefined,
  description: undefined,
  keywords: undefined,
  name: undefined,
  version: undefined,
  logo: undefined,
  noSearchField: false,
  noLanguageSelector: false,
  noGenerateAutoSearch: undefined,
  builtIn: false,
  noHeader: false,
  noMenu: false
});

exports.MaterialDocsSystemContext = MaterialDocsSystemContext;

var useMaterialDocsSystem = function useMaterialDocsSystem() {
  return _react.default.useContext(MaterialDocsSystemContext);
};

var _default = useMaterialDocsSystem;
exports.default = _default;