"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getChildrenFromContainer;

var _getContainerByType = _interopRequireDefault(require("./getContainerByType"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * Author: Andrieiev Danil |  danssg08@gmail.com | https://github.com/DanilAndreev
 * Copyright (C) 2020.
 */
function getChildrenFromContainer(children, types) {
  var invert = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var multiple = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  var containers = (0, _getContainerByType.default)(children, types, invert, multiple);

  if (Array.isArray(containers)) {
    return containers.map(function (container) {
      return container.props.children;
    }).flat(1);
  } else if (containers) {
    return containers.props.children;
  }

  return null;
}